/* BtReceiver.c generated by valac 0.56.17, the Vala compiler
 * generated from BtReceiver.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Torikulhabib <torik.habib@gamail.com>
 *
 */

#include <granite.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BT_RECEIVER (bt_receiver_get_type ())
#define BT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BT_RECEIVER, BtReceiver))
#define BT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BT_RECEIVER, BtReceiverClass))
#define IS_BT_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BT_RECEIVER))
#define IS_BT_RECEIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BT_RECEIVER))
#define BT_RECEIVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BT_RECEIVER, BtReceiverClass))

typedef struct _BtReceiver BtReceiver;
typedef struct _BtReceiverClass BtReceiverClass;
typedef struct _BtReceiverPrivate BtReceiverPrivate;

#define BLUETOOTH_OBEX_TYPE_TRANSFER (bluetooth_obex_transfer_get_type ())
#define BLUETOOTH_OBEX_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER, BluetoothObexTransfer))
#define BLUETOOTH_OBEX_IS_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER))
#define BLUETOOTH_OBEX_TRANSFER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_OBEX_TYPE_TRANSFER, BluetoothObexTransferIface))

typedef struct _BluetoothObexTransfer BluetoothObexTransfer;
typedef struct _BluetoothObexTransferIface BluetoothObexTransferIface;

#define BLUETOOTH_OBEX_TYPE_TRANSFER_PROXY (bluetooth_obex_transfer_proxy_get_type ())
enum  {
	BT_RECEIVER_0_PROPERTY,
	BT_RECEIVER_SESSION_PROPERTY,
	BT_RECEIVER_NUM_PROPERTIES
};
static GParamSpec* bt_receiver_properties[BT_RECEIVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _BluetoothObexTransferIface {
	GTypeInterface parent_iface;
	void (*cancel) (BluetoothObexTransfer* self, GError** error);
	void (*resume) (BluetoothObexTransfer* self, GError** error);
	void (*suspend) (BluetoothObexTransfer* self, GError** error);
	gchar* (*get_status) (BluetoothObexTransfer* self);
	char* (*get_session) (BluetoothObexTransfer* self);
	gchar* (*get_name) (BluetoothObexTransfer* self);
	gchar* (*get_Type) (BluetoothObexTransfer* self);
	guint64 (*get_time) (BluetoothObexTransfer* self);
	guint64 (*get_size) (BluetoothObexTransfer* self);
	guint64 (*get_transferred) (BluetoothObexTransfer* self);
	gchar* (*get_filename) (BluetoothObexTransfer* self);
};

struct _BtReceiver {
	GraniteDialog parent_instance;
	BtReceiverPrivate * priv;
	BluetoothObexTransfer* transfer;
};

struct _BtReceiverClass {
	GraniteDialogClass parent_class;
};

struct _BtReceiverPrivate {
	GtkProgressBar* progressbar;
	GtkLabel* device_label;
	GtkLabel* directory_label;
	GtkLabel* progress_label;
	GtkLabel* filename_label;
	GtkLabel* rate_label;
	GtkImage* device_image;
	GNotification* notification;
	gchar* path_folder;
	gchar* _session;
	gint start_time;
	guint64 total_size;
};

static gint BtReceiver_private_offset;
static gpointer bt_receiver_parent_class = NULL;

VALA_EXTERN GType bt_receiver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BtReceiver, g_object_unref)
VALA_EXTERN GType bluetooth_obex_transfer_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint bluetooth_obex_transfer_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType bluetooth_obex_transfer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothObexTransfer, g_object_unref)
VALA_EXTERN BtReceiver* bt_receiver_new (GtkApplication* application);
VALA_EXTERN BtReceiver* bt_receiver_construct (GType object_type,
                                   GtkApplication* application);
VALA_EXTERN void bt_receiver_set_transfer (BtReceiver* self,
                               const gchar* devicename,
                               const gchar* deviceicon,
                               const gchar* objectpath);
static void ___lambda17_ (BtReceiver* self,
                   GVariant* changed,
                   gchar** invalid);
static void bt_receiver_tranfer_progress (BtReceiver* self);
static void ____lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                      GVariant* changed_properties,
                                                      gchar** invalidated_properties,
                                                      gpointer self);
VALA_EXTERN guint64 bluetooth_obex_transfer_get_size (BluetoothObexTransfer* self);
VALA_EXTERN char* bluetooth_obex_transfer_get_session (BluetoothObexTransfer* self);
VALA_EXTERN void bt_receiver_set_session (BtReceiver* self,
                              const gchar* value);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_name (BluetoothObexTransfer* self);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_status (BluetoothObexTransfer* self);
VALA_EXTERN gchar* bluetooth_obex_transfer_get_filename (BluetoothObexTransfer* self);
static void bt_receiver_on_transfer_progress (BtReceiver* self,
                                       guint64 transferred);
VALA_EXTERN guint64 bluetooth_obex_transfer_get_transferred (BluetoothObexTransfer* self);
static void bt_receiver_move_to_folder (BtReceiver* self,
                                 const gchar* file,
                                 GError** error);
static GFile* bt_receiver_change_name (BtReceiver* self,
                                const gchar* uri);
static gchar* bt_receiver_format_time (BtReceiver* self,
                                gint seconds);
VALA_EXTERN const gchar* bt_receiver_get_session (BtReceiver* self);
static GObject * bt_receiver_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _bt_receiver___lambda18_ (BtReceiver* self,
                               gint response_id);
VALA_EXTERN void bluetooth_obex_transfer_cancel (BluetoothObexTransfer* self,
                                     GError** error);
static void __bt_receiver___lambda18__gtk_dialog_response (GtkDialog* _sender,
                                                    gint response_id,
                                                    gpointer self);
static gboolean _bt_receiver___lambda19_ (BtReceiver* self);
static gboolean __bt_receiver___lambda19__gtk_widget_delete_event (GtkWidget* _sender,
                                                            GdkEventAny* event,
                                                            gpointer self);
static void bt_receiver_finalize (GObject * obj);
static GType bt_receiver_get_type_once (void);
static void _vala_bt_receiver_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_bt_receiver_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
bt_receiver_get_instance_private (BtReceiver* self)
{
	return G_STRUCT_MEMBER_P (self, BtReceiver_private_offset);
}

BtReceiver*
bt_receiver_construct (GType object_type,
                       GtkApplication* application)
{
	BtReceiver * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (BtReceiver*) g_object_new (object_type, "application", application, "resizable", FALSE, NULL);
	return self;
}

BtReceiver*
bt_receiver_new (GtkApplication* application)
{
	return bt_receiver_construct (TYPE_BT_RECEIVER, application);
}

static void
___lambda17_ (BtReceiver* self,
              GVariant* changed,
              gchar** invalid)
{
	g_return_if_fail (changed != NULL);
	bt_receiver_tranfer_progress (self);
}

static void
____lambda17__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                 GVariant* changed_properties,
                                                 gchar** invalidated_properties,
                                                 gpointer self)
{
	___lambda17_ ((BtReceiver*) self, changed_properties, invalidated_properties);
}

void
bt_receiver_set_transfer (BtReceiver* self,
                          const gchar* devicename,
                          const gchar* deviceicon,
                          const gchar* objectpath)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	GtkImage* _tmp8_;
	GThemedIcon* _tmp9_;
	GThemedIcon* _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (devicename != NULL);
	g_return_if_fail (deviceicon != NULL);
	g_return_if_fail (objectpath != NULL);
	_tmp0_ = self->priv->device_label;
	_tmp1_ = g_markup_printf_escaped (_ ("<b>From</b>: %s"), devicename);
	_tmp2_ = _tmp1_;
	gtk_label_set_markup (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->directory_label;
	_tmp4_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
	_tmp5_ = g_markup_printf_escaped (_ ("<b>To</b>: %s"), _tmp4_);
	_tmp6_ = _tmp5_;
	gtk_label_set_label (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	if (deviceicon == NULL) {
		_tmp7_ = "bluetooth";
	} else {
		_tmp7_ = deviceicon;
	}
	_tmp8_ = self->priv->device_image;
	_tmp9_ = (GThemedIcon*) g_themed_icon_new (_tmp7_);
	_tmp10_ = _tmp9_;
	gtk_image_set_from_gicon (_tmp8_, (GIcon*) _tmp10_, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	_g_object_unref0 (_tmp10_);
	self->priv->start_time = (gint) g_get_real_time ();
	{
		BluetoothObexTransfer* _tmp11_ = NULL;
		BluetoothObexTransfer* _tmp12_;
		BluetoothObexTransfer* _tmp13_;
		BluetoothObexTransfer* _tmp14_;
		BluetoothObexTransfer* _tmp15_;
		guint64 _tmp16_;
		guint64 _tmp17_;
		BluetoothObexTransfer* _tmp18_;
		char* _tmp19_;
		char* _tmp20_;
		char* _tmp21_;
		GtkLabel* _tmp22_;
		BluetoothObexTransfer* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp12_ = (BluetoothObexTransfer*) g_initable_new (BLUETOOTH_OBEX_TYPE_TRANSFER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.bluez.obex", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", objectpath, "g-interface-name", "org.bluez.obex.Transfer1", NULL);
		_tmp11_ = (BluetoothObexTransfer*) _tmp12_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp13_ = _tmp11_;
		_tmp11_ = NULL;
		_g_object_unref0 (self->transfer);
		self->transfer = _tmp13_;
		_tmp14_ = self->transfer;
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) ____lambda17__g_dbus_proxy_g_properties_changed, self, 0);
		_tmp15_ = self->transfer;
		_tmp16_ = bluetooth_obex_transfer_get_size (_tmp15_);
		_tmp17_ = _tmp16_;
		self->priv->total_size = _tmp17_;
		_tmp18_ = self->transfer;
		_tmp19_ = bluetooth_obex_transfer_get_session (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = _tmp20_;
		bt_receiver_set_session (self, (const gchar*) _tmp21_);
		_g_free0 (_tmp21_);
		_tmp22_ = self->priv->filename_label;
		_tmp23_ = self->transfer;
		_tmp24_ = bluetooth_obex_transfer_get_name (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = _tmp25_;
		_tmp27_ = g_markup_printf_escaped (_ ("<b>Filename</b>: %s"), _tmp26_);
		_tmp28_ = _tmp27_;
		gtk_label_set_markup (_tmp22_, _tmp28_);
		_g_free0 (_tmp28_);
		_g_free0 (_tmp26_);
		_g_object_unref0 (_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp29_ = e;
		_tmp30_ = _tmp29_->message;
		g_warning ("BtReceiver.vala:150: %s", _tmp30_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
bt_receiver_tranfer_progress (BtReceiver* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		BluetoothObexTransfer* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GQuark _tmp5_ = 0U;
		static GQuark _tmp4_label0 = 0;
		static GQuark _tmp4_label1 = 0;
		static GQuark _tmp4_label2 = 0;
		static GQuark _tmp4_label3 = 0;
		_tmp0_ = self->transfer;
		_tmp1_ = bluetooth_obex_transfer_get_status (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
		g_free (_tmp3_);
		if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("error")))) {
			switch (0) {
				default:
				{
					GNotification* _tmp6_;
					GtkImage* _tmp7_;
					GIcon* _tmp8_;
					GIcon* _tmp9_;
					GIcon* _tmp10_;
					GNotification* _tmp11_;
					GNotification* _tmp12_;
					GtkLabel* _tmp13_;
					const gchar* _tmp14_;
					BluetoothObexTransfer* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					GApplication* _tmp21_;
					GNotification* _tmp22_;
					_tmp6_ = self->priv->notification;
					_tmp7_ = self->priv->device_image;
					g_object_get (_tmp7_, "gicon", &_tmp8_, NULL);
					_tmp9_ = _tmp8_;
					_tmp10_ = _tmp9_;
					g_notification_set_icon (_tmp6_, _tmp10_);
					_g_object_unref0 (_tmp10_);
					_tmp11_ = self->priv->notification;
					g_notification_set_title (_tmp11_, _ ("File transfer failed"));
					_tmp12_ = self->priv->notification;
					_tmp13_ = self->priv->device_label;
					_tmp14_ = gtk_label_get_label (_tmp13_);
					_tmp15_ = self->transfer;
					_tmp16_ = bluetooth_obex_transfer_get_name (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = _tmp17_;
					_tmp19_ = g_markup_printf_escaped (_ ("%s <b>File:</b> %s not received"), _tmp14_, _tmp18_);
					_tmp20_ = _tmp19_;
					g_notification_set_body (_tmp12_, _tmp20_);
					_g_free0 (_tmp20_);
					_g_free0 (_tmp18_);
					_tmp21_ = g_application_get_default ();
					_tmp22_ = self->priv->notification;
					g_application_send_notification (_tmp21_, "io.elementary.bluetooth", _tmp22_);
					gtk_widget_destroy ((GtkWidget*) self);
					break;
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("queued")))) {
			switch (0) {
				default:
				{
					break;
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("active")))) {
			switch (0) {
				default:
				{
					gchar* path = NULL;
					BluetoothObexTransfer* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp26_;
					BluetoothObexTransfer* _tmp29_;
					guint64 _tmp30_;
					guint64 _tmp31_;
					_tmp23_ = self->transfer;
					_tmp24_ = bluetooth_obex_transfer_get_filename (_tmp23_);
					_tmp25_ = _tmp24_;
					path = _tmp25_;
					_tmp26_ = path;
					if (_tmp26_ != NULL) {
						const gchar* _tmp27_;
						gchar* _tmp28_;
						_tmp27_ = path;
						_tmp28_ = g_strdup (_tmp27_);
						_g_free0 (self->priv->path_folder);
						self->priv->path_folder = _tmp28_;
					}
					_tmp29_ = self->transfer;
					_tmp30_ = bluetooth_obex_transfer_get_transferred (_tmp29_);
					_tmp31_ = _tmp30_;
					bt_receiver_on_transfer_progress (self, _tmp31_);
					_g_free0 (path);
					break;
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("complete")))) {
			switch (0) {
				default:
				{
					const gchar* _tmp32_;
					_tmp32_ = self->priv->path_folder;
					bt_receiver_move_to_folder (self, _tmp32_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					gtk_widget_destroy ((GtkWidget*) self);
					break;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp33_ = e;
		_tmp34_ = _tmp33_->message;
		g_critical ("BtReceiver.vala:178: %s", _tmp34_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
bt_receiver_move_to_folder (BtReceiver* self,
                            const gchar* file,
                            GError** error)
{
	GFile* src = NULL;
	GFile* _tmp0_;
	GFile* dest = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GNotification* _tmp8_;
	GtkImage* _tmp9_;
	GIcon* _tmp10_;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	GNotification* _tmp13_;
	GNotification* _tmp14_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GApplication* _tmp21_;
	GNotification* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_file_new_for_path (file);
	src = _tmp0_;
	_tmp1_ = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
	_tmp2_ = g_file_get_basename (src);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_build_filename (_tmp1_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = bt_receiver_change_name (self, _tmp5_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	dest = _tmp7_;
	g_file_move (src, dest, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (dest);
		_g_object_unref0 (src);
		return;
	}
	_tmp8_ = self->priv->notification;
	_tmp9_ = self->priv->device_image;
	g_object_get (_tmp9_, "gicon", &_tmp10_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = _tmp11_;
	g_notification_set_icon (_tmp8_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->notification;
	g_notification_set_title (_tmp13_, _ ("File transferred successfully"));
	_tmp14_ = self->priv->notification;
	_tmp15_ = self->priv->device_label;
	_tmp16_ = gtk_label_get_label (_tmp15_);
	_tmp17_ = g_file_get_path (dest);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_markup_printf_escaped (_ ("%s <b>Save to:</b> %s"), _tmp16_, _tmp18_);
	_tmp20_ = _tmp19_;
	g_notification_set_body (_tmp14_, _tmp20_);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp18_);
	_tmp21_ = g_application_get_default ();
	_tmp22_ = self->priv->notification;
	g_application_send_notification (_tmp21_, "io.elementary.bluetooth", _tmp22_);
	_g_object_unref0 (dest);
	_g_object_unref0 (src);
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static GFile*
bt_receiver_change_name (BtReceiver* self,
                         const gchar* uri)
{
	GFile* file_check = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = g_file_new_for_path (uri);
	file_check = _tmp0_;
	_tmp1_ = file_check;
	if (g_file_query_exists (_tmp1_, NULL)) {
		gchar* without_ext = NULL;
		gint last_dot = 0;
		gint last_slash = 0;
		gchar* ext_name = NULL;
		gchar* _tmp4_;
		gchar* time = NULL;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
		last_dot = string_last_index_of (uri, ".", 0);
		last_slash = string_last_index_of (uri, "/", 0);
		if (last_dot < last_slash) {
			gchar* _tmp2_;
			_tmp2_ = g_strdup (uri);
			_g_free0 (without_ext);
			without_ext = _tmp2_;
		} else {
			gchar* _tmp3_;
			_tmp3_ = string_slice (uri, (glong) 0, (glong) last_dot);
			_g_free0 (without_ext);
			without_ext = _tmp3_;
		}
		_tmp4_ = string_substring (uri, (glong) last_dot, (glong) -1);
		ext_name = _tmp4_;
		_tmp5_ = g_date_time_new_now_local ();
		_tmp6_ = _tmp5_;
		_tmp7_ = g_date_time_format (_tmp6_, " (%F %H:%M:%S)");
		_tmp8_ = _tmp7_;
		_g_date_time_unref0 (_tmp6_);
		time = _tmp8_;
		_tmp9_ = without_ext;
		_tmp10_ = time;
		_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = ext_name;
		_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_file_new_for_path (_tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp15_);
		_g_free0 (_tmp12_);
		result = _tmp17_;
		_g_free0 (time);
		_g_free0 (ext_name);
		_g_free0 (without_ext);
		_g_object_unref0 (file_check);
		return result;
	} else {
		result = file_check;
		return result;
	}
}

static void
bt_receiver_on_transfer_progress (BtReceiver* self,
                                  guint64 transferred)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkProgressBar* _tmp7_;
	gint current_time = 0;
	gint elapsed_time = 0;
	guint64 transfer_rate = 0ULL;
	GtkLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	guint64 remaining_time = 0ULL;
	GtkLabel* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->progress_label;
	_tmp1_ = g_format_size_full (transferred, G_FORMAT_SIZE_DEFAULT);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_format_size_full (self->priv->total_size, G_FORMAT_SIZE_DEFAULT);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf (_ ("Receiving…  %s of %s"), _tmp2_, _tmp4_);
	_tmp6_ = _tmp5_;
	gtk_label_set_label (_tmp0_, _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp7_ = self->priv->progressbar;
	gtk_progress_bar_set_fraction (_tmp7_, ((gdouble) transferred) / ((gdouble) self->priv->total_size));
	current_time = (gint) g_get_real_time ();
	elapsed_time = (current_time - self->priv->start_time) / 1000000;
	if (current_time < (self->priv->start_time + 1000000)) {
		return;
	}
	if (elapsed_time == 0) {
		return;
	}
	transfer_rate = transferred / elapsed_time;
	if (transfer_rate == ((guint64) 0)) {
		return;
	}
	_tmp8_ = self->priv->rate_label;
	_tmp9_ = g_format_size_full (transfer_rate, G_FORMAT_SIZE_DEFAULT);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_markup_printf_escaped (_ ("<b>Transfer rate:</b> %s"), _tmp10_);
	_tmp12_ = _tmp11_;
	gtk_label_set_label (_tmp8_, _tmp12_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	remaining_time = (self->priv->total_size - transferred) / transfer_rate;
	_tmp13_ = self->priv->progress_label;
	_tmp14_ = g_format_size_full (transferred, G_FORMAT_SIZE_DEFAULT);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_format_size_full (self->priv->total_size, G_FORMAT_SIZE_DEFAULT);
	_tmp17_ = _tmp16_;
	_tmp18_ = bt_receiver_format_time (self, (gint) remaining_time);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_markup_printf_escaped (_ ("%s of %s received, time remaining %s"), _tmp15_, _tmp17_, _tmp19_);
	_tmp21_ = _tmp20_;
	gtk_label_set_label (_tmp13_, _tmp21_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
}

static gchar*
bt_receiver_format_time (BtReceiver* self,
                         gint seconds)
{
	gint minutes = 0;
	gint hours = 0;
	gchar* _tmp7_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (seconds < 0) {
		seconds = 0;
	}
	if (seconds < 60) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup_printf (ngettext ("%d second", "%d seconds", (gulong) seconds), seconds);
		result = _tmp0_;
		return result;
	}
	if (seconds < (60 * 60)) {
		gchar* _tmp1_;
		minutes = (seconds + 30) / 60;
		_tmp1_ = g_strdup_printf (ngettext ("%d minute", "%d minutes", (gulong) minutes), minutes);
		result = _tmp1_;
		return result;
	}
	hours = seconds / (60 * 60);
	if (seconds < ((60 * 60) * 4)) {
		gchar* h = NULL;
		gchar* _tmp2_;
		gchar* m = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		minutes = ((seconds - ((hours * 60) * 60)) + 30) / 60;
		_tmp2_ = g_strdup_printf (ngettext ("%u hour", "%u hours", (gulong) hours), (guint) hours);
		h = _tmp2_;
		_tmp3_ = g_strdup_printf (ngettext ("%u minute", "%u minutes", (gulong) minutes), (guint) minutes);
		m = _tmp3_;
		_tmp4_ = h;
		_tmp5_ = m;
		_tmp6_ = g_strdup_printf (_ ("%s, %s"), _tmp4_, _tmp5_);
		result = _tmp6_;
		_g_free0 (m);
		_g_free0 (h);
		return result;
	}
	_tmp7_ = g_strdup_printf (ngettext ("approximately %d hour", "approximately %d hours", (gulong) hours), hours);
	result = _tmp7_;
	return result;
}

const gchar*
bt_receiver_get_session (BtReceiver* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_session;
	result = _tmp0_;
	return result;
}

void
bt_receiver_set_session (BtReceiver* self,
                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = bt_receiver_get_session (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_session);
		self->priv->_session = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bt_receiver_properties[BT_RECEIVER_SESSION_PROPERTY]);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_bt_receiver___lambda18_ (BtReceiver* self,
                          gint response_id)
{
	GError* _inner_error0_ = NULL;
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
		{
			BluetoothObexTransfer* _tmp0_;
			_tmp0_ = self->transfer;
			bluetooth_obex_transfer_cancel (_tmp0_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp1_;
			const gchar* _tmp2_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp1_ = e;
			_tmp2_ = _tmp1_->message;
			g_warning ("BtReceiver.vala:120: %s", _tmp2_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		gtk_widget_destroy ((GtkWidget*) self);
	} else {
		gtk_widget_hide_on_delete ((GtkWidget*) self);
	}
}

static void
__bt_receiver___lambda18__gtk_dialog_response (GtkDialog* _sender,
                                               gint response_id,
                                               gpointer self)
{
	_bt_receiver___lambda18_ ((BtReceiver*) self, response_id);
}

static gboolean
_bt_receiver___lambda19_ (BtReceiver* self)
{
	BluetoothObexTransfer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	_tmp0_ = self->transfer;
	_tmp1_ = bluetooth_obex_transfer_get_status (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strcmp0 (_tmp3_, "active") == 0;
	_g_free0 (_tmp3_);
	if (_tmp4_) {
		result = gtk_widget_hide_on_delete ((GtkWidget*) self);
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static gboolean
__bt_receiver___lambda19__gtk_widget_delete_event (GtkWidget* _sender,
                                                   GdkEventAny* event,
                                                   gpointer self)
{
	gboolean result;
	result = _bt_receiver___lambda19_ ((BtReceiver*) self);
	return result;
}

static GObject *
bt_receiver_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BtReceiver * self;
	GNotification* _tmp0_;
	GNotification* _tmp1_;
	GtkImage* icon_image = NULL;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	GtkImage* _tmp6_;
	GtkOverlay* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_ = NULL;
	GtkLabel* _tmp14_ = NULL;
	GtkProgressBar* _tmp15_ = NULL;
	GtkLabel* _tmp16_ = NULL;
	GtkGrid* message_grid = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_;
	GtkOverlay* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkProgressBar* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* _tmp32_;
	GtkGrid* _tmp33_;
	GtkWidget* suggested_button = NULL;
	GtkWidget* _tmp34_;
	GtkWidget* _tmp35_;
	GtkWidget* _tmp36_;
	GtkStyleContext* _tmp37_;
	parent_class = G_OBJECT_CLASS (bt_receiver_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_RECEIVER, BtReceiver);
	_tmp0_ = g_notification_new ("bluetooth");
	_g_object_unref0 (self->priv->notification);
	self->priv->notification = _tmp0_;
	_tmp1_ = self->priv->notification;
	g_notification_set_priority (_tmp1_, G_NOTIFICATION_PRIORITY_NORMAL);
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("io.elementary.bluetooth", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp2_);
	icon_image = _tmp2_;
	_tmp3_ = (GtkImage*) gtk_image_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->device_image);
	self->priv->device_image = _tmp3_;
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp4_);
	overlay = _tmp4_;
	_tmp5_ = overlay;
	_tmp6_ = icon_image;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = overlay;
	_tmp8_ = self->priv->device_image;
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_max_width_chars (_tmp9_, 45);
	gtk_label_set_use_markup (_tmp9_, TRUE);
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->device_label);
	self->priv->device_label = _tmp9_;
	_tmp10_ = self->priv->device_label;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, "primary");
	_tmp12_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_max_width_chars (_tmp12_, 45);
	gtk_label_set_use_markup (_tmp12_, TRUE);
	g_object_set (_tmp12_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp12_, (gfloat) 0);
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->directory_label);
	self->priv->directory_label = _tmp12_;
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_max_width_chars (_tmp13_, 45);
	gtk_label_set_use_markup (_tmp13_, TRUE);
	g_object_set (_tmp13_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->filename_label);
	self->priv->filename_label = _tmp13_;
	_tmp14_ = (GtkLabel*) gtk_label_new (_ ("<b>Transfer rate:</b>"));
	gtk_label_set_max_width_chars (_tmp14_, 45);
	gtk_label_set_use_markup (_tmp14_, TRUE);
	g_object_set (_tmp14_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp14_, (gfloat) 0);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->rate_label);
	self->priv->rate_label = _tmp14_;
	_tmp15_ = (GtkProgressBar*) gtk_progress_bar_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->progressbar);
	self->priv->progressbar = _tmp15_;
	_tmp16_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_max_width_chars (_tmp16_, 45);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, FALSE);
	g_object_set (_tmp16_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp16_, (gfloat) 0);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->progress_label);
	self->priv->progress_label = _tmp16_;
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp17_, 0);
	g_object_set ((GtkWidget*) _tmp17_, "width-request", 450, NULL);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 15);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 10);
	g_object_ref_sink (_tmp17_);
	message_grid = _tmp17_;
	_tmp18_ = message_grid;
	_tmp19_ = overlay;
	gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 3);
	_tmp20_ = message_grid;
	_tmp21_ = self->priv->device_label;
	gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 1, 0, 1, 1);
	_tmp22_ = message_grid;
	_tmp23_ = self->priv->directory_label;
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 1, 1, 1, 1);
	_tmp24_ = message_grid;
	_tmp25_ = self->priv->filename_label;
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 1, 2, 1, 1);
	_tmp26_ = message_grid;
	_tmp27_ = self->priv->rate_label;
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 1, 3, 1, 1);
	_tmp28_ = message_grid;
	_tmp29_ = self->priv->progressbar;
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 1, 4, 1, 1);
	_tmp30_ = message_grid;
	_tmp31_ = self->priv->progress_label;
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 1, 5, 1, 1);
	_tmp32_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp33_ = message_grid;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Close"), (gint) GTK_RESPONSE_CLOSE);
	_tmp34_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Reject"), (gint) GTK_RESPONSE_ACCEPT);
	_tmp35_ = _g_object_ref0 (_tmp34_);
	suggested_button = _tmp35_;
	_tmp36_ = suggested_button;
	_tmp37_ = gtk_widget_get_style_context (_tmp36_);
	gtk_style_context_add_class (_tmp37_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __bt_receiver___lambda18__gtk_dialog_response, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __bt_receiver___lambda19__gtk_widget_delete_event, self, 0);
	_g_object_unref0 (suggested_button);
	_g_object_unref0 (message_grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (icon_image);
	return obj;
}

static void
bt_receiver_class_init (BtReceiverClass * klass,
                        gpointer klass_data)
{
	bt_receiver_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BtReceiver_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bt_receiver_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bt_receiver_set_property;
	G_OBJECT_CLASS (klass)->constructor = bt_receiver_constructor;
	G_OBJECT_CLASS (klass)->finalize = bt_receiver_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BT_RECEIVER_SESSION_PROPERTY, bt_receiver_properties[BT_RECEIVER_SESSION_PROPERTY] = g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
bt_receiver_instance_init (BtReceiver * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	self->priv = bt_receiver_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->path_folder = _tmp0_;
	self->priv->start_time = 0;
	self->priv->total_size = (guint64) 0;
}

static void
bt_receiver_finalize (GObject * obj)
{
	BtReceiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BT_RECEIVER, BtReceiver);
	_g_object_unref0 (self->transfer);
	_g_object_unref0 (self->priv->progressbar);
	_g_object_unref0 (self->priv->device_label);
	_g_object_unref0 (self->priv->directory_label);
	_g_object_unref0 (self->priv->progress_label);
	_g_object_unref0 (self->priv->filename_label);
	_g_object_unref0 (self->priv->rate_label);
	_g_object_unref0 (self->priv->device_image);
	_g_object_unref0 (self->priv->notification);
	_g_free0 (self->priv->path_folder);
	_g_free0 (self->priv->_session);
	G_OBJECT_CLASS (bt_receiver_parent_class)->finalize (obj);
}

static GType
bt_receiver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BtReceiverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bt_receiver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BtReceiver), 0, (GInstanceInitFunc) bt_receiver_instance_init, NULL };
	GType bt_receiver_type_id;
	bt_receiver_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "BtReceiver", &g_define_type_info, 0);
	BtReceiver_private_offset = g_type_add_instance_private (bt_receiver_type_id, sizeof (BtReceiverPrivate));
	return bt_receiver_type_id;
}

GType
bt_receiver_get_type (void)
{
	static volatile gsize bt_receiver_type_id__once = 0;
	if (g_once_init_enter (&bt_receiver_type_id__once)) {
		GType bt_receiver_type_id;
		bt_receiver_type_id = bt_receiver_get_type_once ();
		g_once_init_leave (&bt_receiver_type_id__once, bt_receiver_type_id);
	}
	return bt_receiver_type_id__once;
}

static void
_vala_bt_receiver_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	BtReceiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_RECEIVER, BtReceiver);
	switch (property_id) {
		case BT_RECEIVER_SESSION_PROPERTY:
		g_value_set_string (value, bt_receiver_get_session (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bt_receiver_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	BtReceiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BT_RECEIVER, BtReceiver);
	switch (property_id) {
		case BT_RECEIVER_SESSION_PROPERTY:
		bt_receiver_set_session (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

