/* DeviceRow.c generated by valac 0.56.17, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Torikulhabib <torik.habib@gamail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DEVICE_ROW (device_row_get_type ())
#define DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE_ROW, DeviceRow))
#define DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE_ROW, DeviceRowClass))
#define IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE_ROW))
#define IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE_ROW))
#define DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE_ROW, DeviceRowClass))

typedef struct _DeviceRow DeviceRow;
typedef struct _DeviceRowClass DeviceRowClass;
typedef struct _DeviceRowPrivate DeviceRowPrivate;

#define BLUETOOTH_TYPE_DEVICE (bluetooth_device_get_type ())
#define BLUETOOTH_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_DEVICE, BluetoothDevice))
#define BLUETOOTH_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_DEVICE))
#define BLUETOOTH_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_TYPE_DEVICE, BluetoothDeviceIface))

typedef struct _BluetoothDevice BluetoothDevice;
typedef struct _BluetoothDeviceIface BluetoothDeviceIface;

#define BLUETOOTH_TYPE_DEVICE_PROXY (bluetooth_device_proxy_get_type ())

#define BLUETOOTH_TYPE_ADAPTER (bluetooth_adapter_get_type ())
#define BLUETOOTH_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_ADAPTER, BluetoothAdapter))
#define BLUETOOTH_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_ADAPTER))
#define BLUETOOTH_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_TYPE_ADAPTER, BluetoothAdapterIface))

typedef struct _BluetoothAdapter BluetoothAdapter;
typedef struct _BluetoothAdapterIface BluetoothAdapterIface;

#define BLUETOOTH_TYPE_ADAPTER_PROXY (bluetooth_adapter_proxy_get_type ())
enum  {
	DEVICE_ROW_0_PROPERTY,
	DEVICE_ROW_DEVICE_PROPERTY,
	DEVICE_ROW_ADAPTER_PROPERTY,
	DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* device_row_properties[DEVICE_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	DEVICE_ROW_SEND_FILE_SIGNAL,
	DEVICE_ROW_NUM_SIGNALS
};
static guint device_row_signals[DEVICE_ROW_NUM_SIGNALS] = {0};

struct _DeviceRow {
	GtkListBoxRow parent_instance;
	DeviceRowPrivate * priv;
};

struct _DeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _BluetoothDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothDevice* self, GError** error);
	void (*connect) (BluetoothDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*connect_finish) (BluetoothDevice* self, GAsyncResult* _res_, GError** error);
	void (*connect_profile) (BluetoothDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*disconnect_finish) (BluetoothDevice* self, GAsyncResult* _res_, GError** error);
	void (*disconnect_profile) (BluetoothDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothDevice* self, GError** error);
	gchar** (*get_UUIDs) (BluetoothDevice* self, gint* result_length1);
	gboolean (*get_blocked) (BluetoothDevice* self);
	void (*set_blocked) (BluetoothDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothDevice* self);
	gboolean (*get_legacy_pairing) (BluetoothDevice* self);
	gboolean (*get_paired) (BluetoothDevice* self);
	gboolean (*get_trusted) (BluetoothDevice* self);
	void (*set_trusted) (BluetoothDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothDevice* self);
	char* (*get_adapter) (BluetoothDevice* self);
	gchar* (*get_address) (BluetoothDevice* self);
	gchar* (*get_alias) (BluetoothDevice* self);
	void (*set_alias) (BluetoothDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothDevice* self);
	gchar* (*get_modalias) (BluetoothDevice* self);
	gchar* (*get_name) (BluetoothDevice* self);
	guint16 (*get_appearance) (BluetoothDevice* self);
	guint32 (*get_class) (BluetoothDevice* self);
};

struct _BluetoothAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*start_discovery_finish) (BluetoothAdapter* self, GAsyncResult* _res_, GError** error);
	void (*stop_discovery) (BluetoothAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*stop_discovery_finish) (BluetoothAdapter* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothAdapter* self, gint* result_length1);
	gboolean (*get_discoverable) (BluetoothAdapter* self);
	void (*set_discoverable) (BluetoothAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothAdapter* self);
	gboolean (*get_pairable) (BluetoothAdapter* self);
	void (*set_pairable) (BluetoothAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothAdapter* self);
	void (*set_powered) (BluetoothAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothAdapter* self);
	gchar* (*get_alias) (BluetoothAdapter* self);
	void (*set_alias) (BluetoothAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothAdapter* self);
	gchar* (*get_name) (BluetoothAdapter* self);
	guint (*get_class) (BluetoothAdapter* self);
	guint (*get_discoverable_timeout) (BluetoothAdapter* self);
	guint (*get_pairable_timeout) (BluetoothAdapter* self);
};

struct _DeviceRowPrivate {
	BluetoothDevice* _device;
	BluetoothAdapter* _adapter;
	GtkButton* send_button;
	GtkImage* state;
	GtkLabel* state_label;
};

struct _Block16Data {
	int _ref_count_;
	DeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint DeviceRow_private_offset;
static gpointer device_row_parent_class = NULL;
static GtkSizeGroup* device_row_size_group;
static GtkSizeGroup* device_row_size_group = NULL;

VALA_EXTERN GType device_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeviceRow, g_object_unref)
VALA_EXTERN GType bluetooth_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint bluetooth_device_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
VALA_EXTERN GType bluetooth_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothDevice, g_object_unref)
VALA_EXTERN GType bluetooth_adapter_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint bluetooth_adapter_register_object (void* object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error);
VALA_EXTERN GType bluetooth_adapter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothAdapter, g_object_unref)
VALA_EXTERN DeviceRow* device_row_new (BluetoothDevice* device,
                           BluetoothAdapter* adapter);
VALA_EXTERN DeviceRow* device_row_construct (GType object_type,
                                 BluetoothDevice* device,
                                 BluetoothAdapter* adapter);
static gchar* device_row_device_icon (DeviceRow* self);
VALA_EXTERN BluetoothDevice* device_row_get_device (DeviceRow* self);
VALA_EXTERN gchar* bluetooth_device_get_icon (BluetoothDevice* self);
VALA_EXTERN gchar* bluetooth_device_get_address (BluetoothDevice* self);
static void device_row_set_status (DeviceRow* self,
                            gboolean status);
static void device_row_set_device (DeviceRow* self,
                            BluetoothDevice* value);
VALA_EXTERN BluetoothAdapter* device_row_get_adapter (DeviceRow* self);
static void device_row_set_adapter (DeviceRow* self,
                             BluetoothAdapter* value);
static GObject * device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
VALA_EXTERN gchar* bluetooth_device_get_alias (BluetoothDevice* self);
VALA_EXTERN gboolean bluetooth_adapter_get_powered (BluetoothAdapter* self);
VALA_EXTERN gboolean bluetooth_device_get_connected (BluetoothDevice* self);
static void _device_row___lambda27_ (DeviceRow* self,
                              GVariant* changed,
                              gchar** invalid);
static void __device_row___lambda27__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                 GVariant* changed_properties,
                                                                 gchar** invalidated_properties,
                                                                 gpointer self);
static void _device_row___lambda28_ (Block16Data* _data16_,
                              GVariant* changed,
                              gchar** invalid);
static void __device_row___lambda28__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                 GVariant* changed_properties,
                                                                 gchar** invalidated_properties,
                                                                 gpointer self);
static void _device_row___lambda29_ (DeviceRow* self);
static void __device_row___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
static void device_row_finalize (GObject * obj);
static GType device_row_get_type_once (void);
static void _vala_device_row_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_device_row_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
device_row_get_instance_private (DeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, DeviceRow_private_offset);
}

DeviceRow*
device_row_construct (GType object_type,
                      BluetoothDevice* device,
                      BluetoothAdapter* adapter)
{
	DeviceRow * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (adapter != NULL, NULL);
	self = (DeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
	return self;
}

DeviceRow*
device_row_new (BluetoothDevice* device,
                BluetoothAdapter* adapter)
{
	return device_row_construct (TYPE_DEVICE_ROW, device, adapter);
}

static gchar*
device_row_device_icon (DeviceRow* self)
{
	BluetoothDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	static GQuark _tmp4_label2 = 0;
	static GQuark _tmp4_label3 = 0;
	static GQuark _tmp4_label4 = 0;
	static GQuark _tmp4_label5 = 0;
	static GQuark _tmp4_label6 = 0;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = bluetooth_device_get_icon (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
	g_free (_tmp3_);
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("audio-card")))) {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup (_ ("Speaker"));
				result = _tmp6_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("input-gaming")))) {
		switch (0) {
			default:
			{
				gchar* _tmp7_;
				_tmp7_ = g_strdup (_ ("Controller"));
				result = _tmp7_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("input-keyboard")))) {
		switch (0) {
			default:
			{
				gchar* _tmp8_;
				_tmp8_ = g_strdup (_ ("Keyboard"));
				result = _tmp8_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("input-mouse")))) {
		switch (0) {
			default:
			{
				gchar* _tmp9_;
				_tmp9_ = g_strdup (_ ("Mouse"));
				result = _tmp9_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("input-tablet")))) {
		switch (0) {
			default:
			{
				gchar* _tmp10_;
				_tmp10_ = g_strdup (_ ("Tablet"));
				result = _tmp10_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("input-touchpad")))) {
		switch (0) {
			default:
			{
				gchar* _tmp11_;
				_tmp11_ = g_strdup (_ ("Touchpad"));
				result = _tmp11_;
				return result;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("phone")))) {
		switch (0) {
			default:
			{
				gchar* _tmp12_;
				_tmp12_ = g_strdup (_ ("Phone"));
				result = _tmp12_;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				BluetoothDevice* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp13_ = self->priv->_device;
				_tmp14_ = bluetooth_device_get_address (_tmp13_);
				_tmp15_ = _tmp14_;
				result = _tmp15_;
				return result;
			}
		}
	}
}

static void
device_row_set_status (DeviceRow* self,
                       gboolean status)
{
	const gchar* _tmp0_ = NULL;
	GtkImage* _tmp1_;
	g_return_if_fail (self != NULL);
	if (status) {
		_tmp0_ = "emblem-enabled";
	} else {
		_tmp0_ = "emblem-disabled";
	}
	_tmp1_ = self->priv->state;
	g_object_set (_tmp1_, "icon-name", _tmp0_, NULL);
}

BluetoothDevice*
device_row_get_device (DeviceRow* self)
{
	BluetoothDevice* result;
	BluetoothDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
device_row_set_device (DeviceRow* self,
                       BluetoothDevice* value)
{
	BluetoothDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = device_row_get_device (self);
	if (old_value != value) {
		BluetoothDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, device_row_properties[DEVICE_ROW_DEVICE_PROPERTY]);
	}
}

BluetoothAdapter*
device_row_get_adapter (DeviceRow* self)
{
	BluetoothAdapter* result;
	BluetoothAdapter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_adapter;
	result = _tmp0_;
	return result;
}

static void
device_row_set_adapter (DeviceRow* self,
                        BluetoothAdapter* value)
{
	BluetoothAdapter* old_value;
	g_return_if_fail (self != NULL);
	old_value = device_row_get_adapter (self);
	if (old_value != value) {
		self->priv->_adapter = value;
		g_object_notify_by_pspec ((GObject *) self, device_row_properties[DEVICE_ROW_ADAPTER_PROPERTY]);
	}
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
	g_atomic_int_inc (&_data16_->_ref_count_);
	return _data16_;
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
		DeviceRow* self;
		self = _data16_->self;
		_g_object_unref0 (_data16_->label);
		_g_object_unref0 (_data16_->image);
		_g_object_unref0 (self);
		g_slice_free (Block16Data, _data16_);
	}
}

static void
_device_row___lambda27_ (DeviceRow* self,
                         GVariant* changed,
                         gchar** invalid)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	powered = _tmp3_;
	_tmp4_ = powered;
	if (_tmp4_ != NULL) {
		BluetoothAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_adapter;
		_tmp6_ = bluetooth_adapter_get_powered (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
	}
	_g_variant_unref0 (powered);
}

static void
__device_row___lambda27__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                            GVariant* changed_properties,
                                                            gchar** invalidated_properties,
                                                            gpointer self)
{
	_device_row___lambda27_ ((DeviceRow*) self, changed_properties, invalidated_properties);
}

static void
_device_row___lambda28_ (Block16Data* _data16_,
                         GVariant* changed,
                         gchar** invalid)
{
	DeviceRow* self;
	GVariant* connected = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* name = NULL;
	GVariantType* _tmp8_;
	GVariantType* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GVariant* icon = NULL;
	GVariantType* _tmp18_;
	GVariantType* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	GVariant* _tmp22_;
	self = _data16_->self;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Connected", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	connected = _tmp3_;
	_tmp4_ = connected;
	if (_tmp4_ != NULL) {
		BluetoothDevice* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_device;
		_tmp6_ = bluetooth_device_get_connected (_tmp5_);
		_tmp7_ = _tmp6_;
		device_row_set_status (self, _tmp7_);
	}
	_tmp8_ = g_variant_type_new ("s");
	_tmp9_ = _tmp8_;
	_tmp10_ = g_variant_lookup_value (changed, "Name", _tmp9_);
	_tmp11_ = _tmp10_;
	_g_variant_type_free0 (_tmp9_);
	name = _tmp11_;
	_tmp12_ = name;
	if (_tmp12_ != NULL) {
		GtkLabel* _tmp13_;
		BluetoothDevice* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp13_ = _data16_->label;
		_tmp14_ = self->priv->_device;
		_tmp15_ = bluetooth_device_get_alias (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = _tmp16_;
		gtk_label_set_label (_tmp13_, _tmp17_);
		_g_free0 (_tmp17_);
	}
	_tmp18_ = g_variant_type_new ("s");
	_tmp19_ = _tmp18_;
	_tmp20_ = g_variant_lookup_value (changed, "Icon", _tmp19_);
	_tmp21_ = _tmp20_;
	_g_variant_type_free0 (_tmp19_);
	icon = _tmp21_;
	_tmp22_ = icon;
	if (_tmp22_ != NULL) {
		gchar* _tmp23_ = NULL;
		BluetoothDevice* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GtkImage* _tmp28_;
		_tmp24_ = self->priv->_device;
		_tmp25_ = bluetooth_device_get_icon (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp23_ = _tmp26_;
		if (_tmp23_ == NULL) {
			gchar* _tmp27_;
			_tmp27_ = g_strdup ("bluetooth");
			_g_free0 (_tmp23_);
			_tmp23_ = _tmp27_;
		}
		_tmp28_ = _data16_->image;
		g_object_set (_tmp28_, "icon-name", _tmp23_, NULL);
		_g_free0 (_tmp23_);
	}
	_g_variant_unref0 (icon);
	_g_variant_unref0 (name);
	_g_variant_unref0 (connected);
}

static void
__device_row___lambda28__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                            GVariant* changed_properties,
                                                            gchar** invalidated_properties,
                                                            gpointer self)
{
	_device_row___lambda28_ (self, changed_properties, invalidated_properties);
}

static void
_device_row___lambda29_ (DeviceRow* self)
{
	BluetoothDevice* _tmp0_;
	GtkWidget* _tmp1_;
	_tmp0_ = self->priv->_device;
	g_signal_emit (self, device_row_signals[DEVICE_ROW_SEND_FILE_SIGNAL], 0, _tmp0_);
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_widget_destroy (_tmp1_);
}

static void
__device_row___lambda29__gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
	_device_row___lambda29_ ((DeviceRow*) self);
}

static GObject *
device_row_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DeviceRow * self;
	Block16Data* _data16_;
	gchar* _tmp0_ = NULL;
	BluetoothDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_ = NULL;
	GtkLabel* _tmp7_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp8_;
	GtkOverlay* _tmp9_;
	BluetoothDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkOverlay* _tmp14_;
	GtkImage* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkImage* _tmp17_;
	gchar* device_name = NULL;
	BluetoothDevice* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp31_;
	GtkLabel* _tmp32_ = NULL;
	gchar* _tmp33_;
	GtkButton* _tmp34_ = NULL;
	GtkSizeGroup* _tmp35_;
	GtkButton* _tmp36_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp37_ = NULL;
	GtkGrid* _tmp38_;
	GtkOverlay* _tmp39_;
	GtkGrid* _tmp40_;
	GtkLabel* _tmp41_;
	GtkGrid* _tmp42_;
	GtkLabel* _tmp43_;
	GtkGrid* _tmp44_;
	GtkButton* _tmp45_;
	GtkGrid* _tmp46_;
	BluetoothAdapter* _tmp47_;
	gboolean _tmp48_;
	gboolean _tmp49_;
	BluetoothDevice* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	BluetoothAdapter* _tmp53_;
	BluetoothDevice* _tmp54_;
	GtkLabel* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	GtkButton* _tmp60_;
	parent_class = G_OBJECT_CLASS (device_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE_ROW, DeviceRow);
	_data16_ = g_slice_new0 (Block16Data);
	_data16_->_ref_count_ = 1;
	_data16_->self = g_object_ref (self);
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_device_get_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("bluetooth");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp5_);
	_data16_->image = _tmp5_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-disabled", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp6_;
	_tmp7_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_xalign (_tmp7_, (gfloat) 0);
	gtk_label_set_use_markup (_tmp7_, TRUE);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp7_;
	_tmp8_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp8_);
	overlay = _tmp8_;
	_tmp9_ = overlay;
	_tmp10_ = self->priv->_device;
	_tmp11_ = bluetooth_device_get_address (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = overlay;
	_tmp15_ = _data16_->image;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = overlay;
	_tmp17_ = self->priv->state;
	gtk_overlay_add_overlay (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->_device;
	_tmp19_ = bluetooth_device_get_alias (_tmp18_);
	_tmp20_ = _tmp19_;
	device_name = _tmp20_;
	_tmp21_ = device_name;
	if (_tmp21_ == NULL) {
		BluetoothDevice* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gboolean _tmp26_;
		_tmp22_ = self->priv->_device;
		_tmp23_ = bluetooth_device_get_icon (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = _tmp24_;
		_tmp26_ = _tmp25_ != NULL;
		_g_free0 (_tmp25_);
		if (_tmp26_) {
			gchar* _tmp27_;
			_tmp27_ = device_row_device_icon (self);
			_g_free0 (device_name);
			device_name = _tmp27_;
		} else {
			BluetoothDevice* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			_tmp28_ = self->priv->_device;
			_tmp29_ = bluetooth_device_get_address (_tmp28_);
			_tmp30_ = _tmp29_;
			_g_free0 (device_name);
			device_name = _tmp30_;
		}
	}
	_tmp31_ = device_name;
	_tmp32_ = (GtkLabel*) gtk_label_new (_tmp31_);
	gtk_label_set_ellipsize (_tmp32_, PANGO_ELLIPSIZE_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp32_, TRUE);
	gtk_label_set_xalign (_tmp32_, (gfloat) 0);
	g_object_ref_sink (_tmp32_);
	_data16_->label = _tmp32_;
	_tmp33_ = g_strdup (_ ("Send"));
	_tmp34_ = (GtkButton*) gtk_button_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
	gtk_button_set_label (_tmp34_, _tmp33_);
	_g_free0 (_tmp33_);
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->send_button);
	self->priv->send_button = _tmp34_;
	_tmp35_ = device_row_size_group;
	_tmp36_ = self->priv->send_button;
	gtk_size_group_add_widget (_tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp37_, "margin", 6, NULL);
	gtk_grid_set_column_spacing (_tmp37_, 6);
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp37_, GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp37_);
	grid = _tmp37_;
	_tmp38_ = grid;
	_tmp39_ = overlay;
	gtk_grid_attach (_tmp38_, (GtkWidget*) _tmp39_, 0, 0, 1, 2);
	_tmp40_ = grid;
	_tmp41_ = _data16_->label;
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 1, 0, 1, 1);
	_tmp42_ = grid;
	_tmp43_ = self->priv->state_label;
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 1, 1, 1, 1);
	_tmp44_ = grid;
	_tmp45_ = self->priv->send_button;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 4, 0, 1, 2);
	_tmp46_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp46_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp47_ = self->priv->_adapter;
	_tmp48_ = bluetooth_adapter_get_powered (_tmp47_);
	_tmp49_ = _tmp48_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp49_);
	_tmp50_ = self->priv->_device;
	_tmp51_ = bluetooth_device_get_connected (_tmp50_);
	_tmp52_ = _tmp51_;
	device_row_set_status (self, _tmp52_);
	_tmp53_ = self->priv->_adapter;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __device_row___lambda27__g_dbus_proxy_g_properties_changed, self, 0);
	_tmp54_ = self->priv->_device;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __device_row___lambda28__g_dbus_proxy_g_properties_changed, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
	_tmp55_ = self->priv->state_label;
	_tmp56_ = device_row_device_icon (self);
	_tmp57_ = _tmp56_;
	_tmp58_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp57_);
	_tmp59_ = _tmp58_;
	gtk_label_set_label (_tmp55_, _tmp59_);
	_g_free0 (_tmp59_);
	_g_free0 (_tmp57_);
	_tmp60_ = self->priv->send_button;
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __device_row___lambda29__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_free0 (device_name);
	_g_object_unref0 (overlay);
	_g_free0 (_tmp0_);
	block16_data_unref (_data16_);
	_data16_ = NULL;
	return obj;
}

static void
device_row_class_init (DeviceRowClass * klass,
                       gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	device_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DeviceRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_device_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_device_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = device_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = device_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ROW_DEVICE_PROPERTY, device_row_properties[DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ROW_ADAPTER_PROPERTY, device_row_properties[DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	device_row_signals[DEVICE_ROW_SEND_FILE_SIGNAL] = g_signal_new ("send-file", TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_TYPE_DEVICE);
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (device_row_size_group);
	device_row_size_group = _tmp0_;
}

static void
device_row_instance_init (DeviceRow * self,
                          gpointer klass)
{
	self->priv = device_row_get_instance_private (self);
}

static void
device_row_finalize (GObject * obj)
{
	DeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE_ROW, DeviceRow);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->send_button);
	_g_object_unref0 (self->priv->state);
	_g_object_unref0 (self->priv->state_label);
	G_OBJECT_CLASS (device_row_parent_class)->finalize (obj);
}

static GType
device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeviceRow), 0, (GInstanceInitFunc) device_row_instance_init, NULL };
	GType device_row_type_id;
	device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DeviceRow", &g_define_type_info, 0);
	DeviceRow_private_offset = g_type_add_instance_private (device_row_type_id, sizeof (DeviceRowPrivate));
	return device_row_type_id;
}

GType
device_row_get_type (void)
{
	static volatile gsize device_row_type_id__once = 0;
	if (g_once_init_enter (&device_row_type_id__once)) {
		GType device_row_type_id;
		device_row_type_id = device_row_get_type_once ();
		g_once_init_leave (&device_row_type_id__once, device_row_type_id);
	}
	return device_row_type_id__once;
}

static void
_vala_device_row_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	DeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE_ROW, DeviceRow);
	switch (property_id) {
		case DEVICE_ROW_DEVICE_PROPERTY:
		g_value_set_object (value, device_row_get_device (self));
		break;
		case DEVICE_ROW_ADAPTER_PROPERTY:
		g_value_set_object (value, device_row_get_adapter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_device_row_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	DeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE_ROW, DeviceRow);
	switch (property_id) {
		case DEVICE_ROW_DEVICE_PROPERTY:
		device_row_set_device (self, g_value_get_object (value));
		break;
		case DEVICE_ROW_ADAPTER_PROPERTY:
		device_row_set_adapter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

